#ifndef SORTHEADERCTRL_H
#define SORTHEADERCTRL_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

 
//===========================================================================
// Summary:
//     The CSortHeaderCtrl class derived from CHeaderCtrl
//      Sort Header 
//===========================================================================

class CSortHeaderCtrl : public CHeaderCtrl
{
// Construction
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Sort Header , Constructs a CSortHeaderCtrl object.
	//		Returns A  value.
	CSortHeaderCtrl();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSortHeaderCtrl)
	public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Serialize, Reads or writes this object from or to an archive.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		ar---Specifies a CArchive& ar object.
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// C Sort Header , Destructor of class CSortHeaderCtrl
	// This member function is also a virtual function, you can Override it if you need,  
	//		Returns A  value.
	virtual ~CSortHeaderCtrl();

	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Sort Arrow, Sets a specify value to current class CSortHeaderCtrl
	// Parameters:
	//		iColumn---iColumn, Specifies A integer value.  
	//		bAscending---bAscending, Specifies A Boolean value.
	void SetSortArrow( const int iColumn, const BOOL bAscending );

	// Generated message map functions
protected:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Draw Item, Draws current object to the specify device.
	// Parameters:
	//		lpDrawItemStruct---Draw Item Struct, Specifies a LPDRAWITEMSTRUCT lpDrawItemStruct object.
	void DrawItem( LPDRAWITEMSTRUCT lpDrawItemStruct );

 
	// Sort Column, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_iSortColumn;
 
	// Sort Ascending, This member sets TRUE if it is right.  
	BOOL m_bSortAscending;

	//{{AFX_MSG(CSortHeaderCtrl)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	
	//-----------------------------------------------------------------------
	// Summary:
	// E C L A R E_ M E S S A G E_ M A P, None Description.
	//		Returns A  value.
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // SORTHEADERCTRL_H
