 
// VisioDrawView.cpp : CVisioDrawView ʵ
//

#include "stdafx.h"
// SHARED_HANDLERS ʵԤͼɸѡ
// ATL Ŀнж壬Ŀĵ롣
#ifndef SHARED_HANDLERS
#include "VisioDraw.h"
#endif

#include "VisioDrawDoc.h"
#include "VisioDrawView.h"
#include <io.h>
#include <direct.h>
#include <stdlib.h>
#include "XDXml.h"
#include "FOPVisioStencilConverter.h"
#include "OutputDlg.h"
#include "HMIDupSetDlg.h"
#include "HMIRotateDupSetDlg.h"
#include "MainFrm.h"

// CVisioDrawView

/////////////////////////////////////////////////////////////////////////////
// CVisioDrawView
static int nFontSizeExt[] =
{ 8, 9, 10, 11, 12, 14, 16, 18, 20, 22, 24, 26, 28, 36, 48, 72,80,88,96,128,168,272,405,524,624 };

IMPLEMENT_DYNCREATE(CVisioDrawView, CFOTabPageView)

BEGIN_MESSAGE_MAP(CVisioDrawView, CFOTabPageView)
	// ׼ӡ
	ON_COMMAND(ID_FILE_PRINT, &CFOTabPageView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CFOTabPageView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CVisioDrawView::OnFilePrintPreview)
	ON_WM_CONTEXTMENU()
	ON_WM_RBUTTONUP()
	ON_COMMAND(ID_CONVERT_SVG_SHAPES, &CVisioDrawView::OnConvertSvgShapes)
	ON_UPDATE_COMMAND_UI(ID_CONVERT_SVG_SHAPES, &CVisioDrawView::OnUpdateConvertSvgShapes)
	ON_COMMAND(ID_FILE_EXPORT_HTML, &CVisioDrawView::OnFileExportHtml)
	ON_UPDATE_COMMAND_UI(ID_FILE_EXPORT_HTML, &CVisioDrawView::OnUpdateFileExportHtml)
	ON_COMMAND(ID_FONT_BOLD, OnFontStyleBold)
	ON_UPDATE_COMMAND_UI(ID_FONT_BOLD, OnUpdateFontStyleBold)
	ON_COMMAND(ID_FONT_ITALIC, OnFontStyleItalic)
	ON_UPDATE_COMMAND_UI(ID_FONT_ITALIC, OnUpdateFontStyleItalic)
	ON_COMMAND(ID_FONT_UNDERLINE, OnFontStyleUnderline)
	ON_UPDATE_COMMAND_UI(ID_FONT_UNDERLINE, OnUpdateFontStyleUnderline)
	ON_COMMAND(ID_FONT_INCREASE, OnFontBig)
	ON_UPDATE_COMMAND_UI(ID_FONT_INCREASE, OnUpdateFontBig)
	ON_COMMAND(ID_FONT_DECREASE, OnFontSmall)
	ON_UPDATE_COMMAND_UI(ID_FONT_DECREASE, OnUpdateFontSmall)
	ON_COMMAND(ID_FONT_LEFT_ALIGN, OnFontLeftAlign)
	ON_UPDATE_COMMAND_UI(ID_FONT_LEFT_ALIGN, OnUpdateFontLeftAlign)
	ON_COMMAND(ID_FONT_RIGHT_ALIGN, OnFontRightAlign)
	ON_UPDATE_COMMAND_UI(ID_FONT_RIGHT_ALIGN, OnUpdateFontRightAlign)
	ON_COMMAND(ID_FONT_CENTER, OnFontCenter)
	ON_UPDATE_COMMAND_UI(ID_FONT_CENTER, OnUpdateFontCenter)
	ON_COMMAND(ID_FONT_TOP_ALIGN, OnFontTopAlign)
	ON_UPDATE_COMMAND_UI(ID_FONT_TOP_ALIGN, OnUpdateFontTopAlign)
	ON_COMMAND(ID_FONT_BOTTOM_ALIGN, OnFontBottomAlign)
	ON_UPDATE_COMMAND_UI(ID_FONT_BOTTOM_ALIGN, OnUpdateFontBottomAlign)
	ON_COMMAND(ID_FONT_VCENTER_ALIGN, OnFontVcenterAlign)
	ON_UPDATE_COMMAND_UI(ID_FONT_VCENTER_ALIGN, OnUpdateFontVcenterAlign)
	ON_COMMAND(ID_COLOR_THEME, &CVisioDrawView::OnColorTheme)
	ON_UPDATE_COMMAND_UI(ID_COLOR_THEME, &CVisioDrawView::OnUpdateColorTheme)
	ON_COMMAND(ID_EXPORT_CANVAS, &CVisioDrawView::OnExportCanvas)
	ON_UPDATE_COMMAND_UI(ID_EXPORT_CANVAS, &CVisioDrawView::OnUpdateExportCanvas)
	ON_COMMAND(ID_EDIT_DUP, OnEditDup)
	ON_UPDATE_COMMAND_UI(ID_EDIT_DUP, OnUpdateEditDup)
	ON_COMMAND(ID_FILE_PREVIEWWEB, OnFilePreviewweb)
	ON_COMMAND(ID_SETAS_DEFAULT, OnSetasDefault)
	ON_UPDATE_COMMAND_UI(ID_SETAS_DEFAULT, OnUpdateSetasDefault)
	ON_COMMAND(ID_DUP_SCALE, OnDupScale)
	ON_UPDATE_COMMAND_UI(ID_DUP_SCALE, OnUpdateDupScale)
	ON_COMMAND(ID_ROTATE_DUP, OnRotateDup)
	ON_UPDATE_COMMAND_UI(ID_ROTATE_DUP, OnUpdateRotateDup)
	ON_COMMAND(ID_EXPORT_SVG, &CVisioDrawView::OnExportSvg)
	ON_UPDATE_COMMAND_UI(ID_EXPORT_SVG, &CVisioDrawView::OnUpdateExportSvg)
	ON_COMMAND(ID_LAY_LAYER, &CVisioDrawView::OnLayLayer)
	ON_UPDATE_COMMAND_UI(ID_LAY_LAYER, &CVisioDrawView::OnUpdateLayLayer)
	ON_COMMAND(ID_LAY_HORZ, &CVisioDrawView::OnLayHorz)
	ON_COMMAND(ID_LAY_VERT, &CVisioDrawView::OnLayVert)
	ON_CBN_SELENDOK(ID_FONT_FACE, OnFontname)
	ON_COMMAND(ID_FONT_FACE, OnFontname)
	ON_UPDATE_COMMAND_UI(ID_FONT_FACE, OnUpdateFontname)
	ON_CBN_SELENDOK(ID_FONT_SIZE, OnFontSize)
	ON_COMMAND(ID_FONT_SIZE, OnFontSize)
	ON_UPDATE_COMMAND_UI(ID_FONT_SIZE, OnUpdateFontSize)
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_VIEW_RULER, &CVisioDrawView::OnViewRuler)
	ON_UPDATE_COMMAND_UI(ID_VIEW_RULER, &CVisioDrawView::OnUpdateViewRuler)
	ON_COMMAND(ID_CHANGE_ALL_PROP, &CVisioDrawView::OnChangeAllProp)
	ON_UPDATE_COMMAND_UI(ID_CHANGE_ALL_PROP, &CVisioDrawView::OnUpdateChangeAllProp)
	ON_COMMAND(ID_HIDE_ALL_SNAP, &CVisioDrawView::OnHideAllSnap)
	ON_UPDATE_COMMAND_UI(ID_HIDE_ALL_SNAP, &CVisioDrawView::OnUpdateHideAllSnap)
	ON_COMMAND(ID_FONT_COLOR, &CVisioDrawView::OnFontColor)
	ON_UPDATE_COMMAND_UI(ID_FONT_COLOR, &CVisioDrawView::OnUpdateFontColor)
	ON_COMMAND(ID_CLONE_NOW, &CVisioDrawView::OnCloneNow)
	ON_UPDATE_COMMAND_UI(ID_CLONE_NOW, &CVisioDrawView::OnUpdateCloneNow)
	ON_COMMAND(ID_VIEW_PAPERCOLOR, &CVisioDrawView::OnViewPapercolor)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PAPERCOLOR, &CVisioDrawView::OnUpdateViewPapercolor)
END_MESSAGE_MAP()

// CVisioDrawView /

CVisioDrawView::CVisioDrawView()
{
	// TODO: ڴ˴ӹ
	m_bCenter = TRUE;
	 
}

CVisioDrawView::~CVisioDrawView()
{
}

void CVisioDrawView::SelectNewShape(CFODrawShape *pShapeX)
{
	CFODrawShape *pShape = NULL;
	CFODrawShapeList lstUpdate;
	POSITION pos = m_listSelectComp.GetHeadPosition();
	while (pos != NULL)
	{
		pShape = (CFODrawShape *)m_listSelectComp.GetNext(pos);
		lstUpdate.AddTail(pShape);
		pShape->SetSelectedMode(FALSE);
	}

	if (pShapeX != NULL && pShapeX->IsKindOf(RUNTIME_CLASS(CFODrawShape)))
	{
		m_listSelectComp.RemoveAll();
		AddToSelection(pShapeX);

		if (lstUpdate.Find(pShapeX) == NULL)
		{
			lstUpdate.AddTail(pShapeX);
		}
	}

	if (lstUpdate.GetCount() >0)
	{
		DoCorrectTabOrder();
		UpdateShapes(&lstUpdate);
	}
}

BOOL CVisioDrawView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ڴ˴ͨ޸
	//  CREATESTRUCT cs ޸Ĵʽ

	return CFOTabPageView::PreCreateWindow(cs);
}

// CVisioDrawView 

void CVisioDrawView::OnDraw(CDC* pDC)
{
	CVisioDrawDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;
	Draw(pDC);
	// TODO: ڴ˴Ϊӻƴ
}


// CVisioDrawView ӡ

void CVisioDrawView::DoAfterDrop(const CPoint &pt, CFODrawShape *pShape)
{
	pt;
	if (pShape == NULL)
	{
		return;
	}
	CheckSelectionChange(TRUE);
	if (!gfxData.m_bWithShareMode)
	{
		return;
	}

	if (HAS_BASE(pShape, CFOCompositeShape))
	{
		CFOCompositeShape *pNew = static_cast<CFOCompositeShape *>(pShape);
		GetCurrentModel()->UpdaterSaveLoad(pNew, pNew->GetType());
	}
}


void CVisioDrawView::UpdateStyle(CFOPShapeDefaultStyle *pStyle)
{
	EndDrag();
	CFOPShapeDefaultStyle oldStyle = GetCurrentModel()->maCurStyle;
	CFOPShapeDefaultStyle m_CurStyle = *pStyle;
	if ((*pStyle != oldStyle) && GetCurrentModel()->GetCompsCount() > 0)
	{

		if ((m_CurStyle != oldStyle) && GetCurrentModel()->GetCompsCount() > 0)
		{
			int nTotal = GetCurrentModel()->GetShapes()->GetCount();
			// Prepare actions.
			BegActionExt(IDS_CMD_MOVETO_CLOSESHAPE, (UINT)FOP_EXT_MOVETO_CLOSESHAPE, TRUE);

			//          CFODrawShapeList m_listWithFill;
			//          CFODrawShapeList m_listLineShape;
			CFODrawShapeList mList;
			GetCurrentModel()->GetAllShapesInDepth(mList);
			POSITION pos = mList.GetHeadPosition();
			while (pos != NULL)
			{
				CFODrawShape *pShape = (CFODrawShape *)mList.GetNext(pos);

				if (!pShape->IsShapeClosed())
				{
					if (1)
					{
						CFOShapeIntAction* pAction = new CFOShapeIntAction(GetCurrentModel(), pShape);
						pAction->ChangePropValue(P_ID_LINE_WIDTH, m_CurStyle.m_nLineShapeWidth);
						AddAction(pAction);
					}

					if (m_CurStyle.m_nLineShapeWidth == 0)
					{
						CFOShapeBoolAction* pAction = new CFOShapeBoolAction(GetCurrentModel(), pShape);
						pAction->ChangePropValue(P_ID_NULL_PEN, TRUE);
						AddAction(pAction);
					}
					else
					{

						CFOShapeBoolAction* pAction = new CFOShapeBoolAction(GetCurrentModel(), pShape);
						pAction->ChangePropValue(P_ID_NULL_PEN, FALSE);
						AddAction(pAction);

					}

					if (1)
					{
						CFOShapeColorAction* pAction = new CFOShapeColorAction(GetCurrentModel(), pShape);
						pAction->ChangePropValue(P_ID_LINE_COLOR, m_CurStyle.m_crLineShape);
						AddAction(pAction);
					}
				}
				else
				{
					if (1)
					{
						CFOShapeIntAction* pAction = new CFOShapeIntAction(GetCurrentModel(), pShape);
						pAction->ChangePropValue(P_ID_LINE_WIDTH, m_CurStyle.m_nLineWidth);
						AddAction(pAction);
					}
					if (m_CurStyle.m_nLineWidth == 0)
					{
						CFOShapeBoolAction* pAction = new CFOShapeBoolAction(GetCurrentModel(), pShape);
						pAction->ChangePropValue(P_ID_NULL_PEN, TRUE);
						AddAction(pAction);
					}
					else
					{

						CFOShapeBoolAction* pAction = new CFOShapeBoolAction(GetCurrentModel(), pShape);
						pAction->ChangePropValue(P_ID_NULL_PEN, FALSE);
						AddAction(pAction);

					}
					if (1)
					{
						CFOShapeColorAction* pAction = new CFOShapeColorAction(GetCurrentModel(), pShape);
						pAction->ChangePropValue(P_ID_LINE_COLOR, m_CurStyle.m_crLine);
						AddAction(pAction);
					}
				}

				if (1)
				{
					CFOShapeColorAction* pAction = new CFOShapeColorAction(GetCurrentModel(), pShape);
					pAction->ChangePropValue(P_ID_SHADOW_COLOR, m_CurStyle.GetShadowColor());
					AddAction(pAction);
				}

				if (m_CurStyle.GetShadow())
				{
					if (1)
					{
						CFOShapeIntAction* pAction = new CFOShapeIntAction(GetCurrentModel(), pShape);
						pAction->ChangePropValue(P_ID_SHADOW_BRUSHTYPE, 1);
						AddAction(pAction);
					}

					if (1)
					{

						CFOShapeBoolAction* pAction = new CFOShapeBoolAction(GetCurrentModel(), pShape);
						pAction->ChangePropValue(P_ID_SHADOW, TRUE);
						AddAction(pAction);

					}

				}
				else
				{
					if (1)
					{
						CFOShapeIntAction* pAction = new CFOShapeIntAction(GetCurrentModel(), pShape);
						pAction->ChangePropValue(P_ID_SHADOW_BRUSHTYPE, 0);
						AddAction(pAction);
					}

					if (1)
					{

						CFOShapeBoolAction* pAction = new CFOShapeBoolAction(GetCurrentModel(), pShape);
						pAction->ChangePropValue(P_ID_SHADOW, FALSE);
						AddAction(pAction);

					}


				}

				if (1)
				{
					CFOShapeColorAction* pAction = new CFOShapeColorAction(GetCurrentModel(), pShape);
					pAction->ChangePropValue(P_ID_BK_COLOR, m_CurStyle.GetBkColor());
					AddAction(pAction);
				}

				if (1)
				{
					CFOShapeColorAction* pAction = new CFOShapeColorAction(GetCurrentModel(), pShape);
					pAction->ChangePropValue(P_ID_PATTERNCOLOR, m_CurStyle.GetPatternColor());
					AddAction(pAction);
				}

				if (1)
				{
					CFOShapeIntAction* pAction = new CFOShapeIntAction(GetCurrentModel(), pShape);
					pAction->ChangePropValue(P_ID_BURSHTYPE, m_CurStyle.GetBrushType());
					AddAction(pAction);
				}

				if (1)
				{

					CFOShapeBoolAction* pAction = new CFOShapeBoolAction(GetCurrentModel(), pShape);
					pAction->ChangePropValue(P_ID_FONT_ITALIC, m_CurStyle.GetItalic());
					AddAction(pAction);

				}
				if (1)
				{
					CFOShapeIntAction* pAction = new CFOShapeIntAction(GetCurrentModel(), pShape);
					pAction->ChangePropValue(P_ID_FONT_WEIGHT, m_CurStyle.GetWeight());
					AddAction(pAction);
				}
				if (1)
				{
					CFOShapeStringAction* pAction = new CFOShapeStringAction(GetCurrentModel(), pShape);
					pAction->ChangePropValue(P_ID_FONT_FACENAME, m_CurStyle.GetFaceName());
					AddAction(pAction);
				}

				if (1)
				{
					CFOShapeIntAction* pAction = new CFOShapeIntAction(GetCurrentModel(), pShape);
					pAction->ChangePropValue(P_ID_FONT_POINTSIZE, m_CurStyle.GetPointSize());
					AddAction(pAction);
				}

				if (1)
				{
					CFOShapeColorAction* pAction = new CFOShapeColorAction(GetCurrentModel(), pShape);
					pAction->ChangePropValue(P_ID_FONT_COLOR, m_CurStyle.GetFontColor());
					AddAction(pAction);
				}

			}

			EndAction();
			//           
			CFOMultiModelPropAction* pAction2 = GetCurrentModel()->GetModelPropAction();
			pAction2->AddColor(m_CurStyle.m_crCanvas, M_ID_BK_COLOR);

			if (!GetCurrentModel()->Do(pAction2, TRUE))
			{
				delete pAction2;
			}
			GetCurrentModel()->maCurStyle = m_CurStyle;
			gfxDefStyleData.UpdateCurDef(m_CurStyle);
			GetCurrentModel()->SetModifiedFlag();
		}
	}
	else
	{
		CFOMultiModelPropAction* pAction2 = GetCurrentModel()->GetModelPropAction();
		pAction2->AddColor(pStyle->m_crCanvas, M_ID_BK_COLOR);

		if (!GetCurrentModel()->Do(pAction2, TRUE))
		{
			delete pAction2;
		}
		CExtTabModel *pModel = (CExtTabModel *)(GetCurrentModel());
		pModel->maCurStyle = *pStyle;
		gfxDefStyleData.UpdateCurDef(*pStyle);
		GetCurrentModel()->SetModifiedFlag();
	}

}

void CVisioDrawView::OnFilePrintPreview()
{
#ifndef SHARED_HANDLERS
	AFXPrintPreview(this);
#endif
}

BOOL CVisioDrawView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Ĭ׼
	return CFOTabPageView::OnPreparePrinting(pInfo);
}

void CVisioDrawView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: ӶĴӡǰеĳʼ
	CFOTabPageView::OnBeginPrinting(pDC, pInfo);
}

void CVisioDrawView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: Ӵӡе
	CFOTabPageView::OnEndPrinting(pDC, pInfo);
}

void CVisioDrawView::OnRButtonUp(UINT  nFlags, CPoint point)
{
	CFOTabPageView::OnRButtonUp(nFlags, point);
}

void CVisioDrawView::OnContextMenu(CWnd* pWnd, CPoint point)
{
	if (CMFCPopupMenu::GetSafeActivePopupMenu() != NULL)
	{
		return;
	}

	// make sure window is active
	GetParentFrame()->ActivateFrame();

	CPoint local = point;
	pWnd->ScreenToClient(&local);
	// TODO: Add your message handler code here
	CWnd* pWndPopupOwner = pWnd;

	if (!gfxData.m_bOcxMode)
	{
		while (pWndPopupOwner->GetStyle() & WS_CHILD)
		{
			pWndPopupOwner = pWndPopupOwner->GetParent();
		}

	}

	BOOL bMenuKey = (point == CPoint(-1, -1));

	if (bMenuKey)
	{
		point = CPoint(1, 1);
		pWnd->ClientToScreen(&point);
	}

	CPoint ptHit = local;

	CPoint ptLogi = local;
	FODPtoLP(&ptLogi, 1);

	CClientDC dcx(this);
	PrepareCornerDC(&dcx);
	dcx.DPtoLP(&ptHit, 1);

	BOOL bShowRulerMenu = FALSE;
	if (m_pHorzRuler != NULL && m_pHorzRuler->IsVisible())
	{
		CRect rcMarker(m_pHorzRuler->GetSnapRect());
		if (rcMarker.PtInRect(ptHit))
		{
			bShowRulerMenu = TRUE;
		}
	}

	if (m_pVertRuler != NULL && m_pVertRuler->IsVisible())
	{
		CRect rcMarker(m_pVertRuler->GetSnapRect());
		if (rcMarker.PtInRect(ptHit))
		{
			bShowRulerMenu = TRUE;
		}
	}

	CMenu* pMenu = NULL;
	if (bShowRulerMenu)
	{
		pMenu = CreateRulerMenu();
	}
	else
	{
		BOOL bShow = FALSE;

		if (m_listSelectComp.GetCount() == 1 && m_bEditSpot)
		{
			CFODrawShape *pShape = GetCurrentSelectShape();
			if (pShape->IsKindOf(RUNTIME_CLASS(CFOPathShape)) ||
				HAS_BASE(pShape, CFOPNewPathShape) &&
				!HAS_BASE(pShape, CFOPFontworkShape))
			{
				bShow = TRUE;
			}
		}

		if (!bShow)
		{
			if (m_lstMark.GetMarkCount() > 0)
			{
				CFOPMark *pMark = m_lstMark.GetMark(0);
				if (pMark->HitTest(ptLogi, 8))
				{
					bShow = TRUE;
				}
			}
		}

		if (bShow)
		{
			pMenu = CreatePolyContextMenu();
		}
		else
		{
			pMenu = CreateContextMenu();
		}

	}
	if (pMenu)
	{
		HCURSOR hOldCursor = ::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
		CMFCPopupMenu* pPopupMenu = new CMFCPopupMenu;
		pPopupMenu->SetAutoDestroy(FALSE);
		pPopupMenu->Create(this, point.x, point.y, pMenu->GetSafeHmenu());

		::SetCursor(hOldCursor);
	}
}


void CVisioDrawView::DoSelectionChanged(const BOOL &bWithAction)
{
	CFOPCanvasCore::DoSelectionChanged();
	// Do something.
	CMainFrame *pParent = STATIC_DOWNCAST(CMainFrame, AfxGetMainWnd());
	ASSERT_VALID(pParent);
	if (FALSE == pParent->IsWindowVisible())
		return;

	pParent->m_ExtBar.dlgFill.UpdateProperty(this, bWithAction);
	pParent->m_ExtBar.dlgLine.UpdateProperty(this, bWithAction);
}

// CVisioDrawView 

#ifdef _DEBUG
void CVisioDrawView::AssertValid() const
{
	CFOTabPageView::AssertValid();
}

void CVisioDrawView::Dump(CDumpContext& dc) const
{
	CFOTabPageView::Dump(dc);
}

CVisioDrawDoc* CVisioDrawView::GetDocument() const // ǵ԰汾
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CVisioDrawDoc)));
	return (CVisioDrawDoc*)m_pDocument;
}
#endif //_DEBUG


// CVisioDrawView Ϣ


void CVisioDrawView::OnInitialUpdate()
{
	CVisioDrawDoc* pDoc = (CVisioDrawDoc*)GetDocument();
	if (!pDoc->bOpenDocument)
	{
		CFOTabPageModel *pModel = (CFOTabPageModel *)pDoc->m_pModelManager->InsertTab();

	}

	CFOTabPageModel *pModel = GetDocument()->m_pModelManager->GetTabPtr(0);
	if (pModel != NULL)
	{
		SetTabModel(pModel);
	}

	CFOTabPageView::OnInitialUpdate();

	GetCurrentModel()->ShowPort(TRUE);
	GetCurrentModel()->SetGridColor(RGB(239, 239, 239));
	GetCurrentModel()->SetGridLineType(GRID_VISIO);
	// TODO: ڴרô/û
	LockUpdate(TRUE);
	m_bFixPageResize = TRUE;
	SetRulerUnit(FUNIT_CM);
	GetCurrentModel()->SetUIUnit(FUNIT_CM);
	//	GetCurrentModel()->SetGridX(10.0);
	//	GetCurrentModel()->SetGridY(10.0);
	GetCurrentModel()->SetGridLineType(GRID_VISIO);
	GetCurrentModel()->SetGridColor(RGB(0, 0, 0));
	GetCurrentModel()->SetPointLimitWithPage(theApp.m_bPtLimit);
	m_bSelectWithIn = theApp.m_bWithIn;

	GetCurrentModel()->ShowGrid(FALSE);//theApp.m_bGrid);
	GetCurrentModel()->SetHlpLineVisible(theApp.m_bGuide);
	GetCurrentModel()->EnableSnapDynGrid(TRUE);//theApp.m_bNewSnap);
	GetCurrentModel()->EnableSnapToControlHandle(TRUE);//theApp.m_bGlueToShape);
	GetCurrentModel()->EnableSnapToSpot(TRUE);//theApp.m_bGlueToSpot);
	m_b1stPointAsCenter = theApp.m_bDrawingFromCenter;
	//	GetCurrentModel()->ShowPort(gfxData.m_bfoWithPort);
	GetCurrentModel()->ShowMargin(theApp.m_bMargin);
	GetCurrentModel()->SetSnapToGrid(TRUE);//theApp.m_bGridSnap);
	EnableFreeFormDrawing(theApp.m_bFreeFormDrawing);

	GetCurrentModel()->EnableSnapToHelpLine(TRUE);//theApp.m_bSnapToHelpLine);
	GetCurrentModel()->EnableSnapToIntersectPoint(TRUE);//theApp.m_bSnapToIntersect);
	ShowRulers(theApp.m_bRuler);

	//	ShowRulers(pDoc->m_bRulerVisible);
	UpdateScrollBarSize();
	UpdateRulerMap();
	LockUpdate(FALSE);
}


void xxFOUpdateComp(CFOCompositeShape *pComp)
{
	FOPRect rcTemp = pComp->GetTotalSnapRect();
	//	pComp->ResetCurrentShape();
	pComp->SetPointAt(0, CPoint(rcTemp.left, rcTemp.top));
	pComp->SetPointAt(1, CPoint(rcTemp.right, rcTemp.top));
	pComp->SetPointAt(2, CPoint(rcTemp.right, rcTemp.bottom));
	pComp->SetPointAt(3, CPoint(rcTemp.left, rcTemp.bottom));

	pComp->UpdateDataManager();

	POSITION pos = pComp->GetCompList()->GetHeadPosition();
	while (pos != NULL)
	{
		CFODrawShape *pNewShape = (CFODrawShape *)pComp->GetCompList()->GetNext(pos);
		if (HAS_BASE(pNewShape, CFOCompositeShape))
		{
			CFOCompositeShape *pNew = static_cast<CFOCompositeShape *>(pNewShape);
			xxFOUpdateComp(pNew);
		}

	}
}

void CVisioDrawView::OnConvertSvgShapes()
{
	// TODO: ڴ
	BOOL bSave = gfxData.m_bAllFullGeometry;
	gfxData.m_bAllFullGeometry = TRUE;

	CString strType = _T("Import SVG Files (*.svg)|*.svg||");
	CFileDialog fileDlg(TRUE, _T("SVG Shapes"), _T("*.svg"), OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, strType, NULL);
	if (IDOK != fileDlg.DoModal())
		return;

	CString strFileName = fileDlg.GetPathName();
	CFOPSVGStencilConverter converter(GetCurrentModel(), strFileName);
	converter.Convert();
	converter.Dispose();

	BOOL bNotChanged = FALSE;
	// 	if(GetCurrentModel()->GetCompsCount() == 1)
	// 	{
	// 		CFODrawShape *pShape = (CFODrawShape *)GetCurrentModel()->GetShapes()->GetObject(0);
	// 		if(pShape->IsKindOf(RUNTIME_CLASS(CFOGroupShape)))
	// 		{
	// 			CFOGroupShape *pGroup = static_cast<CFOGroupShape *>(pShape);
	// 			if(pGroup->GetCompCount() < 40)
	// 			{
	// 				GetCurrentModel()->Ungroup(pGroup);
	// 				bNotChanged = TRUE;
	// 			}
	// 			
	// 		}
	// 	}
	// 	else
	{
		m_listSelectComp.RemoveAll();
	}

	if (GetCurrentModel()->GetCompsCount() < 40 && bNotChanged)
	{
		CRect rcTotal = GetCurrentModel()->GetTotalSnapRect(*GetCurrentModel()->GetShapes());
		CFODrawShape *pShape = NULL;
		int xy = 0;
		for (xy = 0; xy < GetCurrentModel()->GetShapes()->Count(); xy++)
		{
			pShape = (CFODrawShape *)GetCurrentModel()->GetShapes()->GetObject(xy);
			if (HAS_BASE(pShape, CFOCompositeShape))
			{
				CFOCompositeShape *pComp = static_cast<CFOCompositeShape *>(pShape);
				xxFOUpdateComp(pComp);

			}
			pShape->OffsetAllPoints(-rcTotal.left, -rcTotal.top);

			if (theApp.dDrawingScale != 1.0)
			{
				pShape->ScaleShape(1.0 / theApp.dDrawingScale, 1.0 / theApp.dDrawingScale, 0, 0);
			}

			pShape->OffsetAllPoints(100, 100);
		}
	}
	else if (theApp.dDrawingScale != 1.0 && GetCurrentModel()->GetCompsCount() < 200)
	{
		CRect rcTotal = GetCurrentModel()->GetTotalSnapRect(*GetCurrentModel()->GetShapes());
		CFODrawShape *pShape = NULL;
		int xy = 0;
		for (xy = 0; xy < GetCurrentModel()->GetShapes()->Count(); xy++)
		{
			pShape = (CFODrawShape *)GetCurrentModel()->GetShapes()->GetObject(xy);
			if (HAS_BASE(pShape, CFOCompositeShape))
			{
				CFOCompositeShape *pComp = static_cast<CFOCompositeShape *>(pShape);
				xxFOUpdateComp(pComp);

			}
			pShape->OffsetAllPoints(-rcTotal.left, -rcTotal.top);

			if (theApp.dDrawingScale != 1.0)
			{
				pShape->ScaleShape(1.0 / theApp.dDrawingScale, 1.0 / theApp.dDrawingScale, 0, 0);
			}



		}
	}
	else
	{
		CFODrawShape *pShape = NULL;
		int xy = 0;
		for (xy = 0; xy < GetCurrentModel()->GetShapes()->Count(); xy++)
		{
			pShape = (CFODrawShape *)GetCurrentModel()->GetShapes()->GetObject(xy);
			if (HAS_BASE(pShape, CFOCompositeShape))
			{
				CFOCompositeShape *pComp = static_cast<CFOCompositeShape *>(pShape);
				xxFOUpdateComp(pComp);

			}
			FOPRect rc = pShape->GetSnapRect();
			pShape->OffsetAllPoints(100, 100);
		}
	}

	if (GetCurrentModel()->GetCompsCount() == 1)
	{
		CFODrawShape *pShape = (CFODrawShape *)GetCurrentModel()->GetShapes()->GetObject(0);
		if (pShape->IsKindOf(RUNTIME_CLASS(CFOGroupShape)))
		{
			CFOGroupShape *pGroup = static_cast<CFOGroupShape *>(pShape);
			if (pGroup->GetCompCount() < 40)
			{
				GetCurrentModel()->Ungroup(pGroup);
				bNotChanged = TRUE;
			}

		}
	}
	{
		CFODrawShape *pShape = NULL;
		int xy = 0;
		for (xy = 0; xy < GetCurrentModel()->GetShapes()->Count(); xy++)
		{
			pShape = (CFODrawShape *)GetCurrentModel()->GetShapes()->GetObject(xy);

			FOPRect rc = pShape->GetSnapRect();

		}
	}
	gfxData.m_bAllFullGeometry = bSave;
	FOPInvalidate();
}

int GetTwipSize(CString str)
{
	LPCTSTR lpszText = str;

	while (*lpszText == ' ' || *lpszText == '\t')
		lpszText++;

	if (lpszText[0] == NULL)
		return -
		1; // no text in control

	double d = _tcstod(lpszText, (LPTSTR*)&lpszText);
	while (*lpszText == ' ' || *lpszText == '\t')
		lpszText++;

	if (*lpszText != NULL)
		return -2;   // not terminated properly

	return (d<0.) ? 0 : (int)(d*1.);
}

void CVisioDrawView::OnFontSize()
{
	// TODO: Add your command handler code here
	CMainFrame *pParent = STATIC_DOWNCAST(CMainFrame, AfxGetMainWnd());
	ASSERT_VALID(pParent);

	CMFCRibbonBar* pRibbon = pParent->GetRibbonBar();
	ASSERT_VALID(pRibbon);

	CMFCRibbonComboBox* pSizeCombo = DYNAMIC_DOWNCAST(
		CMFCRibbonComboBox, pRibbon->FindByID(ID_FONT_SIZE));
	if (pSizeCombo == NULL)
	{
		return;
	}

	int nSize = GetTwipSize(pSizeCombo->GetItem(-1));

	if (nSize == -2)
	{
		return;
	}

	if ((nSize >= 0 && nSize < 20) || nSize > 32760)
	{
		return;
	}

	if (nSize > 0)
	{
		if (m_listSelectComp.GetCount() >= 1)
		{
			CFODrawShape *pObj = GetCurrentSelectShape();
			if (pObj != NULL)
			{
				int nFont = pObj->GetPointSize();
				if (m_listSelectComp.GetCount() == 1)
				{
					CFODrawShape *pCur = GetCurrentSelectShape();
					if (HAS_BASE(pCur, CFOPTableShape))
					{
						CFOPTableShape *pTable = static_cast<CFOPTableShape *>(pCur);
						if (pTable != NULL)
						{
							CFOPTableCellList m_SelectList;
							pTable->GetSelectCells(&m_SelectList);
							if (m_SelectList.GetCount() >0)
							{
								POSITION pos = m_SelectList.GetHeadPosition();
								while (pos != NULL)
								{
									CFOPTableCell *cellX = (CFOPTableCell*)m_SelectList.GetNext(pos);
									if (cellX == NULL)
										continue;

									cellX->SetPointSize(nSize);
								}

								pTable->UpdateControl();
							}
						}
						return;
					}
					else if (HAS_BASE(pCur, FOXNewTableShape))
					{
						FOXNewTableShape *pTable = static_cast<FOXNewTableShape *>(pCur);
						if (pTable != NULL)
						{
							CFOPNewTableCellList m_SelectList;
							pTable->GetSelectCells(&m_SelectList);
							if (m_SelectList.GetCount() >0)
							{
								POSITION pos = m_SelectList.GetHeadPosition();
								while (pos != NULL)
								{
									CFOPNewTableCell *cellX = (CFOPNewTableCell*)m_SelectList.GetNext(pos);
									if (cellX == NULL)
										continue;

									cellX->SetPointSize(nSize);
								}

								pTable->UpdateControl();
							}
						}
						return;
					}
				}
				GetCurrentModel()->ChangeShapesIntProp(&m_listSelectComp, nSize, P_ID_FONT_POINTSIZE);
				GetCurrentModel()->SetModifiedFlag();
				CFOWndDC dc(this);
				POSITION pos = m_listSelectComp.GetHeadPosition();
				while (pos != NULL)
				{
					((CFODrawShape *)m_listSelectComp.GetNext(pos))->AdjustTextBoxSize(&dc);
				}

				UpdateShapes(&m_listSelectComp);
			}
			return;
		}
	}
}

void CVisioDrawView::OnUpdateFontSize(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_listSelectComp.GetCount() > 0);
}

void CVisioDrawView::AddToSelection(CFODrawShape *pShape)
{
	CFOTabPageView::AddToSelection(pShape);
	UpdateCells();
}

void CVisioDrawView::RemoveFromSelection(CFODrawShape *pShape)
{
	CFOTabPageView::RemoveFromSelection(pShape);
	UpdateCells();
}

void CVisioDrawView::RemoveAllFromSelection()
{
	CFOTabPageView::RemoveAllFromSelection();
	UpdateCells();
}

void CVisioDrawView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	CFOTabPageView::OnLButtonUp(nFlags, point);
	UpdateCells();
}

void CVisioDrawView::OnRButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	CFOTabPageView::OnRButtonDown(nFlags, point);

	UpdateCells();
}
BOOL CVisioDrawView::OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point)
{
	// TODO: Add your specialized code here and/or call the base class

	BOOL bReturn = CFOTabPageView::OnDrop(pDataObject, dropEffect, point);

	CMainFrame *pParent = STATIC_DOWNCAST(CMainFrame, AfxGetMainWnd());
	ASSERT_VALID(pParent);

	UpdateCells();

	return bReturn;
}

void CVisioDrawView::UpdateCells()
{
	CMainFrame *pParent = STATIC_DOWNCAST(CMainFrame, AfxGetMainWnd());
	ASSERT_VALID(pParent);
	CMFCRibbonBar* pRibbon = pParent->GetRibbonBar();
	ASSERT_VALID(pRibbon);

	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			if (pParent->IsWindowVisible())
			{
				CMFCRibbonFontComboBox * pFontCombo = DYNAMIC_DOWNCAST(
					CMFCRibbonFontComboBox, pRibbon->FindByID(ID_FONT_FACE));
				if (pFontCombo != NULL)
				{
					CFODrawShape *pCurSel = GetCurrentSelectShape();
					if (pCurSel != NULL)
						pFontCombo->SelectItem(pCurSel->GetFaceName());
				}

				CMFCRibbonComboBox * pSizeCombo = DYNAMIC_DOWNCAST(
					CMFCRibbonComboBox, pRibbon->FindByID(ID_FONT_SIZE));
				if (pSizeCombo != NULL)
				{
					CString str;
					str.Format(_T("%u"), pObj->GetPointSize());
					pSizeCombo->SelectItem(str);
				}

				CMFCRibbonColorButton *pFntColor = DYNAMIC_DOWNCAST(
					CMFCRibbonColorButton, pRibbon->FindByID(ID_FONT_COLOR));
				if (pFntColor != NULL)
				{
					pFntColor->SetColor(pObj->GetFontColor());
				}

 
				//	pParent->pFontNameBox->SelectString(-1,pObj->GetFaceName());
				COLORREF color;
				 
				color = pObj->GetLineColor();
				//		pParent->m_wndFontBar.SendMessageToButtons(ID_LINE_COLOR,CFOPDropColorPickerWellButton::ISetColor, &color);
				//		pParent->m_wndFontBar.SendMessageToButtons(ID_LINE_COLOR,CFOPDropColorPickerWellButton::ISetWellColor, &color);

				color = pObj->GetBkColor();
				//	pParent->m_wndFontBar.SendMessageToButtons(ID_FILL_COLOR,CFOPDropColorPickerWellButton::ISetColor, &color);
				//	pParent->m_wndFontBar.SendMessageToButtons(ID_FILL_COLOR,CFOPDropColorPickerWellButton::ISetWellColor, &color);

				int nWidth = pObj->GetLineWidth();
				//	pParent->m_wndFontBar.SendMessageToButtons(ID_LINE_WIDTH,CFOPDropLineWidthPickerWellButton::ISetLineWidth, &nWidth);
				//		pParent->m_wndFontBar.SendMessageToButtons(ID_LINE_WIDTH,CFOPDropLineWidthPickerWellButton::ISetWellLineWidth, &nWidth);

				int nPenStyle = pObj->GetPenStyle();
				//	pParent->m_wndFontBar.SendMessageToButtons(ID_LINE_TYPE,CFOPDropLineTypePickerWellButton::ISetLineType, &nPenStyle);
				//	pParent->m_wndFontBar.SendMessageToButtons(ID_LINE_TYPE,CFOPDropLineTypePickerWellButton::ISetWellLineType, &nPenStyle);

				// 				pParent->m_crSaveFontColor = pObj->GetFontColor();
				// 				pParent->m_crSaveLineColor = pObj->GetLineColor();
				// 				pParent->m_crSaveFillColor = pObj->GetBkColor();
				// 				pParent->m_nSaveLineType = pObj->GetPenStyle();
				// 				pParent->m_nSaveLineWidth = pObj->GetLineWidth();

			}
		}
	}
	else
	{
		//		pParent->m_crSaveFillColor = GetCurrentModel()->GetBkColor();
		COLORREF color;
		color = GetCurrentModel()->GetBkColor();
		//		pParent->m_wndFontBar.SendMessageToButtons(ID_FILL_COLOR,CFOPDropColorPickerWellButton::ISetColor, &color);
		//	pParent->m_wndFontBar.SendMessageToButtons(ID_FILL_COLOR,CFOPDropColorPickerWellButton::ISetWellColor, &color);
	}

}

void CVisioDrawView::OnFontname()
{
	USES_CONVERSION;
	CMainFrame *pParent = STATIC_DOWNCAST(CMainFrame, AfxGetMainWnd());
	ASSERT_VALID(pParent);
	CMFCRibbonBar* pRibbon = pParent->GetRibbonBar();
	ASSERT_VALID(pRibbon);

	CMFCRibbonFontComboBox * pFontCombo = DYNAMIC_DOWNCAST(
		CMFCRibbonFontComboBox, pRibbon->FindByID(ID_FONT_FACE));
	if (pFontCombo == NULL)
	{
		return;
	}
	
	const CMFCFontInfo* pDesc = pFontCombo->GetFontDesc();
	ASSERT_VALID(pDesc);
	ASSERT(pDesc->m_strName.GetLength() < LF_FACESIZE);
	CString strFace = pDesc->m_strName;
	if (m_listSelectComp.GetCount() == 1)
	{
		CFODrawShape *pCur = GetCurrentSelectShape();
		if (HAS_BASE(pCur, CFOPTableShape))
		{
			CFOPTableShape *pTable = static_cast<CFOPTableShape *>(pCur);
			if (pTable != NULL)
			{
				CFOPTableCellList m_SelectList;
				pTable->GetSelectCells(&m_SelectList);
				if (m_SelectList.GetCount() >0)
				{
					POSITION pos = m_SelectList.GetHeadPosition();
					while (pos != NULL)
					{
						CFOPTableCell *cellX = (CFOPTableCell*)m_SelectList.GetNext(pos);
						if (cellX == NULL)
							continue;

						cellX->SetFaceName(strFace);
					}

					pTable->UpdateControl();
				}
			}
			return;
		}
		else if (HAS_BASE(pCur, FOXNewTableShape))
		{
			FOXNewTableShape *pTable = static_cast<FOXNewTableShape *>(pCur);
			if (pTable != NULL)
			{
				CFOPNewTableCellList m_SelectList;
				pTable->GetSelectCells(&m_SelectList);
				if (m_SelectList.GetCount() >0)
				{
					POSITION pos = m_SelectList.GetHeadPosition();
					while (pos != NULL)
					{
						CFOPNewTableCell *cellX = (CFOPNewTableCell*)m_SelectList.GetNext(pos);
						if (cellX == NULL)
							continue;

						cellX->SetFaceName(strFace);
					}

					pTable->UpdateControl();
				}
			}
			return;
		}
	}

	GetCurrentModel()->ChangeShapesStringProp(&m_listSelectComp, strFace, P_ID_FONT_FACENAME);

	CFOWndDC dc(this);
	POSITION pos = m_listSelectComp.GetHeadPosition();
	while (pos != NULL)
	{
		((CFODrawShape *)m_listSelectComp.GetNext(pos))->AdjustTextBoxSize(&dc);
	}
	GetCurrentModel()->SetModifiedFlag();
	UpdateShapes(&m_listSelectComp);
	SetFocus();
}

void CVisioDrawView::OnUpdateFontname(CCmdUI *pCmdUI)
{
	// TODO: ڴû洦
	pCmdUI->Enable(m_listSelectComp.GetCount() > 0);
}

void CVisioDrawView::OnUpdateConvertSvgShapes(CCmdUI *pCmdUI)
{
	// TODO: ڴû洦
}

BOOL FDirectoryExists(const CString& Path)
{
#ifdef WIN32
	DWORD dwRetVal = GetFileAttributes(Path);
	if (dwRetVal == 0xFFFFFFFF)
		return FALSE;

	// SB:  check for directory attribute
	else if (dwRetVal & FILE_ATTRIBUTE_DIRECTORY)
		return TRUE;

	return FALSE;
#else
	CFileStatus FileStatus;

	if (CFile::GetStatus(Path, FileStatus) == TRUE  &&
		FileStatus.m_attribute & directory)
	{
		return TRUE;
	} // if
	else if (FileSystemExists(GetFullPathName(Path)))
	{
		return TRUE;
	} // else if

	return FALSE;
#endif
} // DirectoryExists

BOOL FOPMakeDirectory2(const CString& NewDirectory)
{
#ifdef WIN32

	SECURITY_ATTRIBUTES security_attrib;
	security_attrib.nLength = sizeof(SECURITY_ATTRIBUTES);
	security_attrib.lpSecurityDescriptor = NULL;
	security_attrib.bInheritHandle = TRUE;

	BOOL bRetVal = CreateDirectory((const TCHAR *)NewDirectory, &security_attrib);
	return bRetVal;

#else

	int nRetVal = _tmkdir((const char *)NewDirectory);
	if (nRetVal == -1)
	{
		return FALSE;
	}

	return TRUE;

#endif
}

void CVisioDrawView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	// TODO: Add your specialized code here and/or call the base class
	CFOTabPageView::OnUpdate(pSender, lHint, pHint);

	CMainFrame *pParent = STATIC_DOWNCAST(CMainFrame, AfxGetMainWnd());
	ASSERT_VALID(pParent);

	UpdateCells();
	 
}

void CVisioDrawView::OnFileExportHtml()
{
	// TODO: ڴ
	COutputDlg dlg;
	if (dlg.DoModal() == IDOK)
	{
		CString strPath = dlg.m_strPath;
		 
		if (1)
		{
			CString strTitle;
//			mainWnd->GetWindowText(strTitle);
			if (strTitle.IsEmpty())
			{
				strTitle = _T("VisioDraw1");
			}
			CString strFile = strPath + strTitle + ".html";
			CString strMain = strFile;
			OutputMainHtml(strFile, strTitle);
			strPath += strTitle + "\\";

			FOPMakeDirectory2(strPath);

			strFile = strPath + "fixpng.js";
			OutputScript(strFile);

			CString strPathX = AfxGetApp()->m_pszHelpFilePath;
			strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
			{
				CString str1 = _T("Previous_gray.png");

				CString strOtherFile;
				strOtherFile = strPathX + _T("\\ExportHtml\\") + str1;

				CString strTarget = strPath + str1;
				theApp.FOPCopyFile(strOtherFile, strTarget);

			}

			{
				CString str1 = _T("CDLogo_center.png");

				CString strOtherFile;
				strOtherFile = strPathX + _T("\\ExportHtml\\") + str1;

				CString strTarget = strPath + str1;
				theApp.FOPCopyFile(strOtherFile, strTarget);

			}


			{
				CString str1 = _T("Home.png");

				CString strOtherFile;
				strOtherFile = strPathX + _T("\\ExportHtml\\") + str1;

				CString strTarget = strPath + str1;
				theApp.FOPCopyFile(strOtherFile, strTarget);

			}
			{
				CString str1 = _T("Next.png");

				CString strOtherFile;
				strOtherFile = strPathX + _T("\\ExportHtml\\") + str1;

				CString strTarget = strPath + str1;
				theApp.FOPCopyFile(strOtherFile, strTarget);

			}
			{
				CString str1 = _T("CDLogo_left.png");

				CString strOtherFile;
				strOtherFile = strPathX + _T("\\ExportHtml\\") + str1;

				CString strTarget = strPath + str1;
				theApp.FOPCopyFile(strOtherFile, strTarget);

			}
			{
				CString str1 = _T("Next_gray.png");

				CString strOtherFile;
				strOtherFile = strPathX + _T("\\ExportHtml\\") + str1;

				CString strTarget = strPath + str1;
				theApp.FOPCopyFile(strOtherFile, strTarget);

			}
			{
				CString str1 = _T("blank.gif");

				CString strOtherFile;
				strOtherFile = strPathX + _T("\\ExportHtml\\") + str1;

				CString strTarget = strPath + str1;
				theApp.FOPCopyFile(strOtherFile, strTarget);

			}
			{
				CString str1 = _T("CDLogo_right.png");

				CString strOtherFile;
				strOtherFile = strPathX + _T("\\ExportHtml\\") + str1;

				CString strTarget = strPath + str1;
				theApp.FOPCopyFile(strOtherFile, strTarget);


			}

			{

				CString str1 = _T("Previous.png");

				CString strOtherFile;
				strOtherFile = strPathX + _T("\\ExportHtml\\") + str1;

				CString strTarget = strPath + str1;
				theApp.FOPCopyFile(strOtherFile, strTarget);


			}


			CVisioDrawDoc* pDoc = (CVisioDrawDoc*)GetDocument();
			if (pDoc != NULL)
			{

				for (int x = 0; x < pDoc->m_pModelManager->GetTabCount(); x++)
				{
					CExtTabModel *pModelx = (CExtTabModel *)pDoc->m_pModelManager->m_arTabs[x];
					if (pModelx != NULL)
					{

						pModelx->DoOutput(strPath, strTitle, x + 1);

					}
				}

			}

			AfxGetApp()->BeginWaitCursor();
			Sleep(1000);

			AfxGetApp()->EndWaitCursor();

			ShellExecute(0, "open", strMain, 0, 0, SW_SHOWNORMAL);
		}

	}
}

void CVisioDrawView::OutputMainHtml(CString strFileName, const CString &strName)
{
	CStdioFile outFile;
	CFileException ex;
	CString strText;
	if (1)
	{
		if (!outFile.Open(strFileName, CFile::modeWrite | CFile::modeCreate | CFile::typeText, &ex))
		{
			ex.ReportError();
			return;
		}

		strText += "<HTML>\n";
		strText += "<HEAD>\n";
		strText += "	<META HTTP-EQUIV=\"CONTENT-TYPE\" CONTENT=\"TEXT/HTML;\">\n";
		strText += "<script>\n";
		strText += "	window.onload = function(){\n";
		strText += "		var hash = window.location.hash;\n";
		strText += "		//console.log(hash);\n";
		strText += "		var src = \"" + strName + "/" + strName + "_Page-1.html\"+ hash;\n";
		strText += "		var tmpElem = document.createElement('div');\n";
		strText += "\n";
		strText += "		tmpElem.innerHTML = '<iframe name=\"aa\" id=\"aa\" src=\"' + src + '\" style=\"width: 100%; height: 100%; \"  frameborder=\"no\"; scrolling = \"yes\">';\n";
		strText += "		var iframe = tmpElem.firstChild;\n";
		strText += "		document.body.appendChild(iframe);\n";
		strText += "		return iframe;\n";
		strText += "}\n";
		strText += "</script> \n";
		strText += "</HEAD>\n";
		strText += "\n";
		strText += "<BODY STYLE=\"MARGIN: 0\"></BODY>\n";
		strText += "</HTML>\n";
		strText += "\n";

		outFile.WriteString(strText);
		outFile.Close();
	}
}

void CVisioDrawView::OutputScript(CString strFileName)
{
	CStdioFile outFile;
	CFileException ex;
	CString strText;
	if (1)
	{
		if (!outFile.Open(strFileName, CFile::modeWrite | CFile::modeCreate | CFile::typeText, &ex))
		{
			ex.ReportError();
			return;
		}

		strText += "// fixPNG(); http://www.tigir.com/js/fixpng.js (author Tigirlas Igor)\n";
		strText += "function fixPNG(element)\n";
		strText += "{\n";
		strText += "	if (/MSIE (5\\.5|6).+Win/.test(navigator.userAgent))\n";
		strText += "	{\n";
		strText += "		var src;\n";
		strText += "		\n";
		strText += "		if (element.tagName=='IMG')\n";
		strText += "		{\n";
		strText += "			if (/\\.png$/.test(element.src))\n";
		strText += "			{\n";
		strText += "				src = element.src;\n";
		strText += "				element.src = \"blank.gif\";\n";
		strText += "			}\n";
		strText += "		}\n";
		strText += "		else\n";
		strText += "		{\n";
		strText += "			src = element.currentStyle.backgroundImage.match(/url\\(\"(.+\\.png)\"\\)/i)\n";
		strText += "			if (src)\n";
		strText += "			{\n";
		strText += "				src = src[1];\n";
		strText += "				element.runtimeStyle.backgroundImage=\"none\";\n";
		strText += "			}\n";
		strText += "		}\n";
		strText += "		\n";
		strText += "		if (src) element.runtimeStyle.filter = \"progid:DXImageTransform.Microsoft.AlphaImageLoader(src='\" + src + \"',sizingMethod='image')\";\n";
		strText += "	}\n";
		strText += "}\n";

		outFile.WriteString(strText);
		outFile.Close();
	}
}


void CVisioDrawView::OnUpdateFileExportHtml(CCmdUI *pCmdUI)
{
	// TODO: ڴû洦
}

void CVisioDrawView::OnFontStyleBold()
{
	// TODO: Add your command handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			int nWeight = pObj->GetWeight();
			if (nWeight < 700)
			{
				GetCurrentModel()->ChangeShapesIntProp(&m_listSelectComp, 700, P_ID_FONT_WEIGHT);
			}
			else
			{
				GetCurrentModel()->ChangeShapesIntProp(&m_listSelectComp, 500, P_ID_FONT_WEIGHT);
			}
		}
		return;
	}

}

void CVisioDrawView::OnUpdateFontStyleBold(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			pCmdUI->SetCheck(pObj->GetWeight() >= 700);
		}
		else
		{
			pCmdUI->SetCheck(FALSE);
		}
	}
	else
	{
		pCmdUI->SetCheck(FALSE);
	}
}

void CVisioDrawView::OnFontStyleItalic()
{
	// TODO: Add your command handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			BOOL bItalic = pObj->GetItalic();
			GetCurrentModel()->ChangeShapesBoolProp(&m_listSelectComp, !bItalic, P_ID_FONT_ITALIC);
		}
		return;
	}
}

void CVisioDrawView::OnUpdateFontStyleItalic(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			pCmdUI->SetCheck(pObj->GetItalic());
		}
		else
		{
			pCmdUI->SetCheck(FALSE);
		}
	}
	else
	{
		pCmdUI->SetCheck(FALSE);
	}
}

void CVisioDrawView::OnFontStyleUnderline()
{
	// TODO: Add your command handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			BOOL bUnderline = pObj->GetUnderline();
			GetCurrentModel()->ChangeShapesBoolProp(&m_listSelectComp, !bUnderline, P_ID_FONT_UNDERLINE);
		}
		return;
	}
}

void CVisioDrawView::OnUpdateFontStyleUnderline(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			pCmdUI->SetCheck(pObj->GetUnderline());
		}
		else
		{
			pCmdUI->SetCheck(FALSE);
		}
	}
	else
	{
		pCmdUI->SetCheck(FALSE);
	}
}

int CVisioDrawView::GetNextFontSize(int nFont)
{
	for (int i = 0; i < 25; i++)
	{
		if (i < 24)
		{
			if (nFont >= nFontSizeExt[i] && nFont < nFontSizeExt[i + 1])
			{
				return nFontSizeExt[i + 1];
			}
		}
	}
	return nFontSizeExt[24];
}

int CVisioDrawView::GetPrevFontSize(int nFont)
{
	for (int i = 0; i < 25; i++)
	{
		if (i > 0)
		{
			if (nFont > nFontSizeExt[i - 1] && nFont <= nFontSizeExt[i])
			{
				return nFontSizeExt[i - 1];
			}
		}
	}
	return nFontSizeExt[0];
}

void CVisioDrawView::OnFontBig()
{
	// TODO: Add your command handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			int nFont = pObj->GetPointSize();

			GetCurrentModel()->ChangeShapesIntProp(&m_listSelectComp, GetNextFontSize(nFont), P_ID_FONT_POINTSIZE);

			CFOWndDC dc(this);
			POSITION pos = m_listSelectComp.GetHeadPosition();
			while (pos != NULL)
			{
				((CFODrawShape *)m_listSelectComp.GetNext(pos))->AdjustTextBoxSize(&dc);
			}

			UpdateShapes(&m_listSelectComp);
		}
		return;
	}
}

void CVisioDrawView::OnUpdateFontBig(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI;
}

void CVisioDrawView::OnFontSmall()
{
	// TODO: Add your command handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			int nFont = pObj->GetPointSize();

			GetCurrentModel()->ChangeShapesIntProp(&m_listSelectComp, GetPrevFontSize(nFont), P_ID_FONT_POINTSIZE);

			CFOWndDC dc(this);
			POSITION pos = m_listSelectComp.GetHeadPosition();
			while (pos != NULL)
			{
				((CFODrawShape *)m_listSelectComp.GetNext(pos))->AdjustTextBoxSize(&dc);
			}

			UpdateShapes(&m_listSelectComp);
		}
		return;
	}
}

void CVisioDrawView::OnUpdateFontSmall(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI;
}

void CVisioDrawView::OnFontLeftAlign()
{
	// TODO: Add your command handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		GetCurrentModel()->ChangeShapesUINTProp(&m_listSelectComp, TextLeft, P_ID_TEXT_HORZ);
	}
}

void CVisioDrawView::OnUpdateFontLeftAlign(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			pCmdUI->SetCheck(pObj->GetTextHorzAlignment() == TextLeft);
		}
		else
		{
			pCmdUI->SetCheck(FALSE);
		}
	}
	else
	{
		pCmdUI->SetCheck(FALSE);
	}
}

void CVisioDrawView::OnFontRightAlign()
{
	// TODO: Add your command handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		GetCurrentModel()->ChangeShapesUINTProp(&m_listSelectComp, TextRight, P_ID_TEXT_HORZ);
	}
}

void CVisioDrawView::OnUpdateFontRightAlign(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			pCmdUI->SetCheck(pObj->GetTextHorzAlignment() == TextRight);
		}
		else
		{
			pCmdUI->SetCheck(FALSE);
		}
	}
	else
	{
		pCmdUI->SetCheck(FALSE);
	}
}

void CVisioDrawView::OnFontCenter()
{
	// TODO: Add your command handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		GetCurrentModel()->ChangeShapesUINTProp(&m_listSelectComp, TextMiddle, P_ID_TEXT_HORZ);
	}
}

void CVisioDrawView::OnUpdateFontCenter(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			pCmdUI->SetCheck(pObj->GetTextHorzAlignment() == TextMiddle);
		}
		else
		{
			pCmdUI->SetCheck(FALSE);
		}
	}
	else
	{
		pCmdUI->SetCheck(FALSE);
	}
}

void CVisioDrawView::OnFontTopAlign()
{
	// TODO: Add your command handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		GetCurrentModel()->ChangeShapesUINTProp(&m_listSelectComp, TextTop, P_ID_TEXT_VERT);
	}
}

void CVisioDrawView::OnUpdateFontTopAlign(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			pCmdUI->SetCheck(pObj->GetTextVertAlignment() == TextTop);
		}
		else
		{
			pCmdUI->SetCheck(FALSE);
		}
	}
	else
	{
		pCmdUI->SetCheck(FALSE);
	}

	BOOL bDesign = GetCurrentModel()->IsDesignMode();

	pCmdUI->Enable(bDesign);
}

void CVisioDrawView::OnFontBottomAlign()
{
	// TODO: Add your command handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		GetCurrentModel()->ChangeShapesUINTProp(&m_listSelectComp, TextBottom, P_ID_TEXT_VERT);
	}
}

void CVisioDrawView::OnUpdateFontBottomAlign(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			pCmdUI->SetCheck(pObj->GetTextVertAlignment() == TextBottom);
		}
		else
		{
			pCmdUI->SetCheck(FALSE);
		}
	}
	else
	{
		pCmdUI->SetCheck(FALSE);
	}

	BOOL bDesign = GetCurrentModel()->IsDesignMode();

	pCmdUI->Enable(bDesign);
}

void CVisioDrawView::OnFontVcenterAlign()
{
	// TODO: Add your command handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		GetCurrentModel()->ChangeShapesUINTProp(&m_listSelectComp, TextCenter, P_ID_TEXT_VERT);
	}
}

void CVisioDrawView::OnUpdateFontVcenterAlign(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	if (m_listSelectComp.GetCount() >= 1)
	{
		CFODrawShape *pObj = GetCurrentSelectShape();
		if (pObj != NULL)
		{
			pCmdUI->SetCheck(pObj->GetTextVertAlignment() == TextCenter);
		}
		else
		{
			pCmdUI->SetCheck(FALSE);
		}
	}
	else
	{
		pCmdUI->SetCheck(FALSE);
	}

	BOOL bDesign = GetCurrentModel()->IsDesignMode();

	pCmdUI->Enable(bDesign);
}


void CVisioDrawView::OnColorTheme()
{
	// TODO: ڴ
	OnFOPFoColortheme();
}


void CVisioDrawView::OnUpdateColorTheme(CCmdUI *pCmdUI)
{
	// TODO: ڴû洦
}


void CVisioDrawView::OnExportCanvas()
{
	// TODO: ڴ
	m_bUpRightMode = FALSE;
	m_bWithEllipseSelect = FALSE;
	m_drawshape = FO_COMP_NONE;
	m_action_state = State_SelectNone;
	m_bWithExportSelect = TRUE;
	m_bMultiSelect = FALSE;
	FOSetSystemCursor(IDC_ARROW);
}


void CVisioDrawView::OnUpdateExportCanvas(CCmdUI *pCmdUI)
{
	// TODO: ڴû洦
	BOOL bDesign = GetCurrentModel()->IsDesignMode();
	pCmdUI->Enable(bDesign);
	pCmdUI->SetCheck(FALSE);
	if (bDesign)
	{
		pCmdUI->SetCheck(m_drawshape == FO_COMP_NONE && !m_bMultiSelect && !m_bWithEllipseSelect && m_bWithExportSelect);
	}
}

void CVisioDrawView::OnEditDup()
{
	// TODO: Add your command handler code here
	int nTotalSelect = m_listSelectComp.GetCount();
	if (nTotalSelect > 0)
	{
		CFODrawShape *pCurSel = (CFODrawShape *)GetCurrentSelectShape();
		COLORREF crBack = RGB(255, 255, 255);
		BOOL bEnable = TRUE;
		POSITION posx = m_listSelectComp.GetHeadPosition();
		while (posx != NULL)
		{
			CFODrawShape *pTemp = m_listSelectComp.GetNext(posx);
			pCurSel = pTemp;
			crBack = pTemp->GetBkColor();

			if (pTemp->IsKindOf(RUNTIME_CLASS(CFOCompositeShape)))
			{

				bEnable = FALSE;
			}
			else
			{
				pTemp->ResetHandleData();
			}
		}
		// 		CFODrawShape *pShape = (CFODrawShape *)GetCurrentSelectShape();
		// 		if(pShape != NULL)
		if (1)
		{
			if (nTotalSelect > 1)
			{
				bEnable = FALSE;
			}

			FOPPoint ptOffset = CPoint(20, 20);
			int		m_nXSpace;
			int		m_nYSpace;
			CHMIDupSetDlg dlg;
			dlg.m_crFG = dlg.m_crBK = crBack;
			dlg.m_bEnable = bEnable;
			if (dlg.DoModal() == IDOK)
			{
				FOPRect rcDraw = GetTotalSelectSnapRect();
				m_nXSpace = dlg.m_nXSpace;
				m_nYSpace = dlg.m_nYSpace;
				int x = 0;
				int y = 0;
				int w = rcDraw.Width();
				int h = rcDraw.Height();

				COLORREF aStartColor = dlg.m_crFG;
				COLORREF aEndColor = dlg.m_crBK;
				BOOL bNeedChange = FALSE;
				if (bEnable)
				{
					if (aStartColor != aEndColor)
					{
						bNeedChange = TRUE;
					}
				}
				int nNumber = dlg.m_nRows * dlg.m_nCols;

				AfxGetApp()->BeginWaitCursor();
				int nCurNow = 0;
				CFODrawShapeList listCopy;
				for (int nRow = 0; nRow < dlg.m_nRows; nRow++)
				{
					for (int nCol = 0; nCol < dlg.m_nCols; nCol++)
					{
						if (nCol == 0 && nRow == 0)
						{
							if (bNeedChange)
							{
								if (pCurSel != NULL)
								{
									BYTE nRed = GetRValue(aStartColor) + (BYTE)(((long)GetRValue(aEndColor) - (long)GetRValue(aStartColor)) * (long)nCurNow / (long)nNumber);
									BYTE nGreen = GetGValue(aStartColor) + (BYTE)(((long)GetGValue(aEndColor) - (long)GetGValue(aStartColor)) *  (long)nCurNow / (long)nNumber);
									BYTE nBlue = GetBValue(aStartColor) + (BYTE)(((long)GetGValue(aEndColor) - (long)GetGValue(aStartColor)) * (long)nCurNow / (long)nNumber);
									COLORREF aNewColor = RGB(nRed, nGreen, nBlue);
									pCurSel->SetBkColor(aNewColor);
								}

							}
						}
						else
						{
							x = nCol * (w + m_nXSpace);

							FOPPoint ptOffset = CPoint(x, y);

							POSITION posx = m_listSelectComp.GetHeadPosition();
							while (posx != NULL)
							{
								CFODrawShape *pTemp = m_listSelectComp.GetNext(posx);
								pTemp->SaveCurrentData();
								if (pTemp->IsKindOf(RUNTIME_CLASS(CFOCompositeShape)))
								{
									CFOCompositeShape *pComp = static_cast<CFOCompositeShape *>(pTemp);
									pComp->ResetHandleDataX();
								}
								else
								{
									pTemp->ResetHandleData();
								}
							}

							CFODrawShapeList maCopy;
							posx = m_listSelectComp.GetHeadPosition();
							while (posx != NULL)
							{
								CFODrawShape *pTemp = m_listSelectComp.GetNext(posx);
								CFODrawShape *pCopy = (CFODrawShape *)pTemp->Copy();
								maCopy.AddTail(pCopy);
								pCopy->m_bInModel = FALSE;
								listCopy.AddTail(pCopy);

								if (1)
								{
									CString strStateText = pTemp->GetStateString();
									if (!strStateText.IsEmpty())
									{
										CString strType = pTemp->GetStateType();
										if (!strType.IsEmpty())
										{
											pTemp->SetStateType(strType);
										}
									}

								}

								if (1)
								{
									CString strStateText = pCopy->GetStateString();
									if (!strStateText.IsEmpty())
									{
										CString strType = pCopy->GetStateType();
										if (!strType.IsEmpty())
										{
											pCopy->SetStateType(strType);
										}
									}

								}


								//	pCopy->SetObjectName(_T("xxx"));
								pCopy->OffsetAllPoints(CPoint(ptOffset));
								pCopy->SetModel(GetCurrentModel());
								pCopy->SetShapeID(0);
								if (GetCurrentModel()->IsEnableUniqueName())
								{
									CString strName = _T("");
									strName = GetCurrentModel()->GetUniqueName(pCopy->GetType());
									pCopy->SetObjectName(strName);
								}

								if (bNeedChange)
								{
									if (pCopy != NULL)
									{
										BYTE nRed = GetRValue(aStartColor) + (BYTE)(((long)GetRValue(aEndColor) - (long)GetRValue(aStartColor)) * (long)nCurNow / (long)nNumber);
										BYTE nGreen = GetGValue(aStartColor) + (BYTE)(((long)GetGValue(aEndColor) - (long)GetGValue(aStartColor)) *  (long)nCurNow / (long)nNumber);
										BYTE nBlue = GetBValue(aStartColor) + (BYTE)(((long)GetGValue(aEndColor) - (long)GetGValue(aStartColor)) * (long)nCurNow / (long)nNumber);
										COLORREF aNewColor = RGB(nRed, nGreen, nBlue);
										pCopy->SetBkColor(aNewColor);
									}

								}
								//	pCopy->TrackUpdatePoints();
								//	pCopy->UpdateComp();
							}

						}
						nCurNow++;
					}

					y = (nRow + 1)* (h + m_nYSpace);
					x = 0;

				}

				if (listCopy.GetCount() > 0)
				{
					CFOAddCompsAction *pAction = new CFOAddCompsAction(GetCurrentModel(), listCopy);

					if (!GetCurrentModel()->Do(pAction, TRUE))
					{
						delete pAction;
					}

				}

			}

			AfxGetApp()->EndWaitCursor();
		}
	}

}

void CVisioDrawView::OnUpdateEditDup(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	BOOL bDesign = GetCurrentModel()->IsDesignMode();
	if (!bDesign)
	{
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(m_listSelectComp.GetCount() >0);
}

void CVisioDrawView::OnDupScale()
{
	// TODO: Add your command handler code here
	CFODrawShapeList listAll;
	listAll.AddTail(&m_listSelectComp);

	COLORREF crBack = RGB(255, 255, 255);
	CFODrawShape *pCurSel = NULL;
	BOOL bEnable = TRUE;
	POSITION posx = listAll.GetHeadPosition();
	while (posx != NULL)
	{
		CFODrawShape *pTemp = listAll.GetNext(posx);
		pCurSel = pTemp;
		crBack = pTemp->GetBkColor();
		pTemp->SaveCurrentData();
		if (pTemp->IsKindOf(RUNTIME_CLASS(CFOCompositeShape)))
		{
			CFOCompositeShape *pComp = static_cast<CFOCompositeShape *>(pTemp);
			pComp->ResetHandleDataX();
			bEnable = FALSE;
		}
		else
		{
			pTemp->ResetHandleData();
		}
	}

	int nTotal = 3;
	int nTotalSelect = listAll.GetCount();
	if (nTotalSelect > 0)
	{
		if (nTotalSelect > 1)
		{
			bEnable = FALSE;
		}
		// 		CFODrawShape *pShape = (CFODrawShape *)GetCurrentSelectShape();
		// 		if(pShape != NULL)

		CHMIScaleDupDlg dlg;
		dlg.m_crFG = dlg.m_crBK = crBack;
		dlg.m_bEnable = bEnable;
		if (dlg.DoModal() != IDOK)
			return;
		nTotal = dlg.m_nCols;
		int		lWidth;
		int		lHeight;

		lWidth = dlg.m_nXSpace;
		lHeight = dlg.m_nYSpace;

		FOPRect rcDraw = GetTotalSelectSnapRect();
		AfxGetApp()->BeginWaitCursor();
		COLORREF aStartColor = dlg.m_crFG;
		COLORREF aEndColor = dlg.m_crBK;
		BOOL bNeedChange = FALSE;
		if (bEnable)
		{
			if (aStartColor != aEndColor)
			{
				bNeedChange = TRUE;
			}
		}
		int nNumber = nTotal;
		int nTotalW = rcDraw.Width();
		int nTotalH = rcDraw.Height();

		CFODrawShapeList listCopy;
		for (int nRow = 0; nRow < nTotal; nRow++)
		{
			if (nRow == 0)
			{
				if (bNeedChange)
				{
					if (pCurSel != NULL)
					{
						BYTE nRed = GetRValue(aStartColor) + (BYTE)(((long)GetRValue(aEndColor) - (long)GetRValue(aStartColor)) * (long)nRow / (long)nNumber);
						BYTE nGreen = GetGValue(aStartColor) + (BYTE)(((long)GetGValue(aEndColor) - (long)GetGValue(aStartColor)) *  (long)nRow / (long)nNumber);
						BYTE nBlue = GetBValue(aStartColor) + (BYTE)(((long)GetGValue(aEndColor) - (long)GetGValue(aStartColor)) * (long)nRow / (long)nNumber);
						COLORREF aNewColor = RGB(nRed, nGreen, nBlue);
						pCurSel->SetBkColor(aNewColor);
					}

				}
			}
			else
			{

				CFODrawShapeList maCopy;
				posx = listAll.GetHeadPosition();
				while (posx != NULL)
				{
					CFODrawShape *pTemp = listAll.GetNext(posx);
					CFODrawShape *pCopy = (CFODrawShape *)pTemp->Copy();
					maCopy.AddTail(pCopy);
					pCopy->m_bInModel = FALSE;
					listCopy.AddTail(pCopy);

					if (1)
					{
						CString strStateText = pTemp->GetStateString();
						if (!strStateText.IsEmpty())
						{
							CString strType = pTemp->GetStateType();
							if (!strType.IsEmpty())
							{
								pTemp->SetStateType(strType);
							}
						}

					}

					if (1)
					{
						CString strStateText = pCopy->GetStateString();
						if (!strStateText.IsEmpty())
						{
							CString strType = pCopy->GetStateType();
							if (!strType.IsEmpty())
							{
								pCopy->SetStateType(strType);
							}
						}

					}

					FOPFraction aWidth(nTotalW + lWidth, nTotalW);
					FOPFraction aHeight(nTotalH + lHeight, nTotalH);

					lWidth += lWidth;
					lHeight += lHeight;

					pCopy->ScaleShape(rcDraw.TopLeft(), aWidth, aHeight);
					//	pCopy->RotateShape(CFODrawHelper::RoundValue(nCurAngle), (double)ptCenter.x, (double)ptCenter.y);

					pCopy->SetModel(GetCurrentModel());
					pCopy->SetShapeID(0);
					if (GetCurrentModel()->IsEnableUniqueName())
					{
						CString strName = _T("");
						strName = GetCurrentModel()->GetUniqueName(pCopy->GetType());
						pCopy->SetObjectName(strName);
					}

					if (bNeedChange)
					{
						BYTE nRed = GetRValue(aStartColor) + (BYTE)(((long)GetRValue(aEndColor) - (long)GetRValue(aStartColor)) * (long)nRow / (long)nNumber);
						BYTE nGreen = GetGValue(aStartColor) + (BYTE)(((long)GetGValue(aEndColor) - (long)GetGValue(aStartColor)) *  (long)nRow / (long)nNumber);
						BYTE nBlue = GetBValue(aStartColor) + (BYTE)(((long)GetGValue(aEndColor) - (long)GetGValue(aStartColor)) * (long)nRow / (long)nNumber);
						COLORREF aNewColor = RGB(nRed, nGreen, nBlue);
						pCopy->SetBkColor(aNewColor);
					}

					// 					pCopy->TrackUpdatePoints();
					// 					pCopy->UpdateHardWay();
				}

			}

			if (listCopy.GetCount() > 0)
			{
				CFOAddCompsAction *pAction = new CFOAddCompsAction(GetCurrentModel(), listCopy);

				if (!GetCurrentModel()->Do(pAction, TRUE))
				{
					delete pAction;
				}

			}

		}

		AfxGetApp()->EndWaitCursor();

	}
}

void CVisioDrawView::OnUpdateDupScale(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	BOOL bDesign = GetCurrentModel()->IsDesignMode();
	if (!bDesign)
	{
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(m_listSelectComp.GetCount() >0);
}

void CVisioDrawView::OnRotateDup()
{
	// TODO: Add your command handler code here
	CFODrawShapeList listAll;
	listAll.AddTail(&m_listSelectComp);

	COLORREF crBack = RGB(255, 255, 255);
	CFODrawShape *pCurSel = NULL;
	BOOL bEnable = TRUE;
	POSITION posx = listAll.GetHeadPosition();
	while (posx != NULL)
	{
		CFODrawShape *pTemp = listAll.GetNext(posx);
		pCurSel = pTemp;
		crBack = pTemp->GetBkColor();
		pTemp->SaveCurrentData();
		if (pTemp->IsKindOf(RUNTIME_CLASS(CFOCompositeShape)))
		{
			CFOCompositeShape *pComp = static_cast<CFOCompositeShape *>(pTemp);
			pComp->ResetHandleDataX();
			bEnable = FALSE;
		}
		else
		{
			pTemp->ResetHandleData();
		}
	}

	int nTotal = 3;
	int nTotalSelect = listAll.GetCount();
	if (nTotalSelect > 0)
	{
		if (nTotalSelect > 1)
		{
			bEnable = FALSE;
		}
		// 		CFODrawShape *pShape = (CFODrawShape *)GetCurrentSelectShape();
		// 		if(pShape != NULL)

		CHMIRotateDupSetDlg dlg;
		dlg.m_crFG = dlg.m_crBK = crBack;
		dlg.m_bEnable = bEnable;
		if (dlg.DoModal() != IDOK)
			return;
		nTotal = dlg.m_nRows;

		CFODrawShape *pCenterShape = NULL;
		CString strComp = dlg.strMoveObj;
		strComp.TrimLeft();
		strComp.TrimRight();
		strComp.MakeLower();
		if (!strComp.IsEmpty())
		{
			pCenterShape = GetCurrentModel()->FindShapeWithKey1(strComp);
		}

		if (pCenterShape == NULL)
		{
			return;
		}

		CRect rcPos = pCenterShape->GetSimpleDrawRect();
		CPoint ptCenter = rcPos.CenterPoint();

		FOPRect rcDraw = GetTotalSelectSnapRect();

		double dStepAngle = dlg.m_nTotalAngle / (double)nTotal;
		double nCurAngle = 0;
		AfxGetApp()->BeginWaitCursor();
		COLORREF aStartColor = dlg.m_crFG;
		COLORREF aEndColor = dlg.m_crBK;
		BOOL bNeedChange = FALSE;
		if (bEnable)
		{
			if (aStartColor != aEndColor)
			{
				bNeedChange = TRUE;
			}
		}
		int nNumber = nTotal;
		CFODrawShapeList listCopy;
		for (int nRow = 0; nRow < nTotal; nRow++)
		{
			if (nRow == 0)
			{
				if (bNeedChange)
				{
					if (pCurSel != NULL)
					{
						BYTE nRed = GetRValue(aStartColor) + (BYTE)(((long)GetRValue(aEndColor) - (long)GetRValue(aStartColor)) * (long)nRow / (long)nNumber);
						BYTE nGreen = GetGValue(aStartColor) + (BYTE)(((long)GetGValue(aEndColor) - (long)GetGValue(aStartColor)) *  (long)nRow / (long)nNumber);
						BYTE nBlue = GetBValue(aStartColor) + (BYTE)(((long)GetGValue(aEndColor) - (long)GetGValue(aStartColor)) * (long)nRow / (long)nNumber);
						COLORREF aNewColor = RGB(nRed, nGreen, nBlue);
						pCurSel->SetBkColor(aNewColor);
					}

				}
			}
			else
			{

				CFODrawShapeList maCopy;
				posx = listAll.GetHeadPosition();
				while (posx != NULL)
				{
					CFODrawShape *pTemp = listAll.GetNext(posx);
					CFODrawShape *pCopy = (CFODrawShape *)pTemp->Copy();
					maCopy.AddTail(pCopy);
					pCopy->m_bInModel = FALSE;
					listCopy.AddTail(pCopy);

					if (1)
					{
						CString strStateText = pTemp->GetStateString();
						if (!strStateText.IsEmpty())
						{
							CString strType = pTemp->GetStateType();
							if (!strType.IsEmpty())
							{
								pTemp->SetStateType(strType);
							}
						}

					}

					if (1)
					{
						CString strStateText = pCopy->GetStateString();
						if (!strStateText.IsEmpty())
						{
							CString strType = pCopy->GetStateType();
							if (!strType.IsEmpty())
							{
								pCopy->SetStateType(strType);
							}
						}

					}


					//					pCopy->SetObjectName(_T("xxx"));
					//	pCopy->OffsetAllPoints(CPoint(ptOffset));
					pCopy->RotateShape(CFODrawHelper::RoundValue(nCurAngle), (double)ptCenter.x, (double)ptCenter.y);
					if (dlg.m_bTextRotate)
					{
						if (HAS_BASE(pCopy, CFOStaticShape))
						{
							pCopy->RotateFromCenter(-pCopy->GetRotateAngle());
						}
					}

					pCopy->SetModel(GetCurrentModel());
					pCopy->SetShapeID(0);
					if (GetCurrentModel()->IsEnableUniqueName())
					{
						CString strName = _T("");
						strName = GetCurrentModel()->GetUniqueName(pCopy->GetType());
						pCopy->SetObjectName(strName);
					}

					if (bNeedChange)
					{
						BYTE nRed = GetRValue(aStartColor) + (BYTE)(((long)GetRValue(aEndColor) - (long)GetRValue(aStartColor)) * (long)nRow / (long)nNumber);
						BYTE nGreen = GetGValue(aStartColor) + (BYTE)(((long)GetGValue(aEndColor) - (long)GetGValue(aStartColor)) *  (long)nRow / (long)nNumber);
						BYTE nBlue = GetBValue(aStartColor) + (BYTE)(((long)GetGValue(aEndColor) - (long)GetGValue(aStartColor)) * (long)nRow / (long)nNumber);
						COLORREF aNewColor = RGB(nRed, nGreen, nBlue);
						pCopy->SetBkColor(aNewColor);
					}

					// 					pCopy->TrackUpdatePoints();
					// 					pCopy->UpdateHardWay();
				}

			}

			nCurAngle += dStepAngle;

			if (listCopy.GetCount() > 0)
			{
				// 				GetCurrentModel()->AddShapes(listCopy);
				// 				UpdateVisibleShapes(&listCopy);
				CFOAddCompsAction *pAction = new CFOAddCompsAction(GetCurrentModel(), listCopy);

				if (!GetCurrentModel()->Do(pAction, TRUE))
				{
					delete pAction;
				}

			}

		}

		AfxGetApp()->EndWaitCursor();

	}
}

void CVisioDrawView::OnUpdateRotateDup(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	BOOL bDesign = GetCurrentModel()->IsDesignMode();
	if (!bDesign)
	{
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(m_listSelectComp.GetCount() >0);
}

void CVisioDrawView::OnFilePreviewweb()
{
	// TODO: Add your command handler code here
	CString strTemp = _T("c:\\temp\\");
	if (!FDirectoryExists(strTemp))
	{
		FOPMakeDirectory2(strTemp);
	}
	BOOL bSave = gfxData.m_bAllFullGeometry;
	gfxData.m_bAllFullGeometry = TRUE;

	CString strFile = strTemp + _T("uccpreview.html");

	CString filename = strFile;
	//	lasttime = fileDlg.GetFileExt();

	GetCurrentModel()->ExportToSVG(filename);
	ShellExecute(NULL, _T("open"), filename, NULL, NULL, SW_SHOWNORMAL);
}

void CVisioDrawView::OnSetasDefault()
{
	// TODO: Add your command handler code here
	if (m_listSelectComp.GetCount() != 1)
	{
		return;
	}

	CFODrawShape *pShape = GetCurrentSelectShape();

	if (pShape != NULL)
	{
		CExtTabModel *pModel = (CExtTabModel *)(GetCurrentModel());

		pModel->maCurStyle.SetFaceName(pShape->GetFaceName());
		pModel->maCurStyle.SetPointSize(pShape->GetPointSize());
		pModel->maCurStyle.SetWeight(pShape->GetWeight());
		pModel->maCurStyle.SetItalic(pShape->GetItalic());
		pModel->maCurStyle.SetFontColor(pShape->GetFontColor());

		if (pShape->IsShapeClosed())
		{
			pModel->maCurStyle.SetLineWidth(pShape->GetLineWidth());
			pModel->maCurStyle.SetLineColor(pShape->GetLineColor());
		}
		else
		{
			pModel->maCurStyle.m_nLineShapeWidth = pShape->GetLineWidth();
			pModel->maCurStyle.m_crLineShape = pShape->GetLineColor();
		}

		pModel->maCurStyle.m_nStartArrow = pShape->GetStartArrowType();
		pModel->maCurStyle.m_nEndArrow = pShape->GetEndArrowType();

		pModel->maCurStyle.SetBrushType(pShape->GetBrushType());
		pModel->maCurStyle.SetBkColor(pShape->GetBkColor());
		pModel->maCurStyle.SetPatternColor(pShape->GetPatternColor());

		pModel->maCurStyle.SetShadow(pShape->GetShadow());

		GetCurrentModel()->SetModifiedFlag();
	}
}

void CVisioDrawView::OnUpdateSetasDefault(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here

}


void CVisioDrawView::OnExportSvg()
{
	// TODO: Add your command handler code here
	static CString lasttime = _T("SVG Export");
	static CString szFilter = _T("Scalable Vector Graphics (*.html)|*.html|SVG File(*.svg)|*.svg||");
	CFileDialog fileDlg(FALSE, _T(".html"), _T(""), OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter, NULL);

	if (fileDlg.DoModal() != IDOK)
		return;

	CString filename = fileDlg.GetFileName();
	lasttime = fileDlg.GetFileExt();

	GetCurrentModel()->ExportToSVG(filename);
	ShellExecute(NULL, _T("open"), filename, NULL, NULL, SW_SHOWNORMAL);
}

void CVisioDrawView::OnUpdateExportSvg(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here

}

void CVisioDrawView::OnLayLayer()
{
	// TODO: Add your command handler code here
	CFOPLayeredLayout layout;

	layout.Initialize(GetCurrentModel(), *GetCurrentModel()->GetFormObjects());
	layout.DoLayoutNew();

	FOPInvalidate(TRUE);
}

void CVisioDrawView::OnUpdateLayLayer(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here

}

void CVisioDrawView::OnLayHorz()
{
	// TODO: ڴ
	CFOPHorzLayout layout;

	layout.Initialize(GetCurrentModel(), *GetCurrentModel()->GetFormObjects());
	layout.DoLayout();

	FOPInvalidate(TRUE);
}


void CVisioDrawView::OnLayVert()
{
	// TODO: ڴ
	CFOPVertLayout layout;

	layout.Initialize(GetCurrentModel(), *GetCurrentModel()->GetFormObjects());
	layout.DoLayout();

	FOPInvalidate(TRUE);
}


void CVisioDrawView::OnViewRuler()
{
	// TODO: Add your command handler code here
	LockUpdate(TRUE);
	CVisioDrawDoc* pDoc = GetDocument();
	BOOL bVisible = IsRulerVisible();
	ShowRulers(!bVisible);
	// 
	UpdateScrollBarSize();
	UpdateRulerMap();
	LockUpdate(FALSE);
	FOPInvalidate(FALSE, TRUE);
	//	pDoc->m_bRulerVisible = !bVisible;
}

void CVisioDrawView::OnUpdateViewRuler(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(IsRulerVisible());
}


void CVisioDrawView::OnChangeAllProp()
{
	// TODO: Add your command handler code here
	OnFOPFoPropManager();
}

void CVisioDrawView::OnUpdateChangeAllProp(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	OnUpdateFOPFoPropManager(pCmdUI);
}


void CVisioDrawView::OnHideAllSnap()
{
	// TODO: ڴ
	gfxData.m_bWithSnap = !gfxData.m_bWithSnap;
}

CFORemoveCompsAction* CVisioDrawView::DoDeleteAction(CFODrawShapeList* pShapeList)
{

	return DoDeleteActionX(pShapeList);
}

CFORemoveCompsAction* CVisioDrawView::DoDeleteActionX(CFODrawShapeList* pShapeList1)
{
	if (pShapeList1->GetCount() <= 0)
	{
		return NULL;
	}

	// 	if(pShapeList1->GetCount() == 1)
	// 	{
	// 		CFODrawShape *pCur = GetCurrentSelectShape();
	// 		if(pCur->IsKindOf(RUNTIME_CLASS(CFOLinkShape)))
	// 		{
	// 			return NULL;
	// 		}
	// 	}

	BOOL bDone = FALSE;
	CFODrawShapeList myListShape;
	//	if(pShapeList1->GetCount() == 1)
	{
		CFODrawShape *pShape = NULL;
		POSITION pos = pShapeList1->GetHeadPosition();
		while (pos != NULL)
		{
			pShape = (CFODrawShape *)pShapeList1->GetNext(pos);
			if (pShape->IsKindOf(RUNTIME_CLASS(CFOLinkShape)))
			{
				CFOLinkShape *pLink1 = static_cast<CFOLinkShape *>(pShape);
				if (myListShape.Find(pLink1) == NULL)
				{
					myListShape.AddTail(pLink1);
				}

				// 				CFODrawPortsShape *pNode = pLink1->GetLinkShape();
				// 				if(pNode != NULL)
				// 				{
				// 					myListShape.AddTail(pNode);
				// 					CFODrawShapeList m_links;
				// 					pNode->GetAllLinks(m_links);
				// 					if(m_links.GetCount() > 0)
				// 					{
				// 						POSITION poslink = m_links.GetHeadPosition();
				// 						while(poslink)
				// 						{
				// 							CFOLinkShape *pLink = (CFOLinkShape *)m_links.GetNext(poslink);
				// 							if(pLink->IsKindOf(RUNTIME_CLASS(CFOLinkShape)))
				// 							{
				// 								if(myListShape.Find(pLink) == NULL)
				// 								{
				// 									myListShape.AddTail(pLink);
				// 								}
				// 							}
				// 						}
				// 					}
				// 				}

				bDone = TRUE;
			}
			else if (pShape->IsKindOf(RUNTIME_CLASS(CFODrawPortsShape)))
			{
				CFODrawPortsShape *pNode = static_cast<CFODrawPortsShape *>(pShape);
				if (myListShape.Find(pNode) == NULL)
				{
					myListShape.AddTail(pNode);
				}

				if (pNode != NULL)
				{
					myListShape.AddTail(pNode);
					CFODrawShapeList m_links;
					pNode->GetAllLinks(m_links);
					if (m_links.GetCount() > 0)
					{
						POSITION poslink = m_links.GetHeadPosition();
						while (poslink)
						{
							CFOLinkShape *pLink = (CFOLinkShape *)m_links.GetNext(poslink);
							if (pLink->IsKindOf(RUNTIME_CLASS(CFOLinkShape)))
							{
								if (myListShape.Find(pLink) == NULL)
								{
									myListShape.AddTail(pLink);
								}
							}
						}
					}
				}

				bDone = TRUE;
			}
			else
			{
				if (myListShape.Find(pShape) == NULL)
				{
					myListShape.AddTail(pShape);
				}

			}
		}
	}

	BOOL bNeedDo = FALSE;
	CFODirectActionMacro *pAction = new CFODirectActionMacro(GetCurrentModel());
	CString strDescri;
	strDescri.LoadString(IDS_CMD_REMOVE_COMP);
	pAction->SetActionDescription(strDescri);
	CFODrawShapeList m_ListTemp;
	CFODrawShapeList m_ListOther;

	CFODrawShape *pShape = NULL;
	POSITION pos = myListShape.GetHeadPosition();
	while (pos != NULL)
	{
		pShape = (CFODrawShape *)myListShape.GetNext(pos);
		if (!pShape->IsDeleteProtect())
		{
			if (pShape->GetMainShape() == NULL)
			{
				m_ListTemp.AddTail((CFODrawShape *)pShape);
			}
			else
			{
				m_ListOther.AddTail((CFODrawShape *)pShape);
			}

			bNeedDo = TRUE;

			if (HAS_BASE(pShape, CFODrawPortsShape))
			{
				CFODrawPortsShape *pShapeTemp = static_cast<CFODrawPortsShape *>(pShape);

				CFODrawShapeList listPorts;
				pShapeTemp->GetAllPorts(listPorts);
				POSITION posport = listPorts.GetHeadPosition();
				CFOPortShape *pPort = NULL;
				while (posport != NULL)
				{
					pPort = (CFOPortShape*)listPorts.GetNext(posport);

					CFODrawShapeList *pLinkList = pPort->GetLinksList();
					POSITION poslink = pLinkList->GetHeadPosition();
					CFOLinkShape *pLinkShape = NULL;
					while (poslink != NULL)
					{
						pLinkShape = (CFOLinkShape *)pLinkList->GetNext(poslink);
						if (pLinkShape != NULL &&
							!pLinkShape->IsStartLinkLocked() &&
							!pLinkShape->IsEndLinkLocked())
						{
							BOOL bHeader = TRUE;
							CFOPortShape *pPortHead = pLinkShape->GetFromPort();
							if (pPortHead != NULL)
							{
								if (pPortHead == pPort)
								{
									bHeader = TRUE;
								}
							}

							CFOPortShape *pPortTail = pLinkShape->GetToPort();
							if (pPortTail != NULL)
							{
								if (pPortTail == pPort)
								{
									bHeader = FALSE;
								}
							}

							CFOBreakLinkAction *pActionTemp = new CFOBreakLinkAction(GetCurrentModel(), pLinkShape, bHeader);
							pActionTemp->SetOldPort(pPort);
							pActionTemp->SetNewPort(NULL);
							pAction->AddAction(pActionTemp);
						}
					}
				}
			}
			else if (HAS_BASE(pShape, CFOLinkShape))
			{
				CFOLinkShape *pLinkShape = static_cast<CFOLinkShape *>(pShape);

				CFOPortShape *pPortHead = pLinkShape->GetFromPort();
				if (pPortHead != NULL)
				{
					CFOBreakLinkAction *pActionTemp = new CFOBreakLinkAction(GetCurrentModel(), pLinkShape, TRUE);
					pActionTemp->SetOldPort(pPortHead);
					pActionTemp->SetNewPort(NULL);
					pAction->AddAction(pActionTemp);
				}


				CFOPortShape *pPortTail = pLinkShape->GetToPort();
				if (pPortTail != NULL)
				{
					CFOBreakLinkAction *pActionTemp = new CFOBreakLinkAction(GetCurrentModel(), pLinkShape, FALSE);
					pActionTemp->SetOldPort(pPortTail);
					pActionTemp->SetNewPort(NULL);
					pAction->AddAction(pActionTemp);
				}
			}
		}
	}

	if (m_ListOther.GetCount() > 0)
	{
		CFODrawShape *pOther = NULL;
		POSITION posother = m_ListOther.GetHeadPosition();
		while (posother != NULL)
		{
			pOther = (CFODrawShape *)m_ListOther.GetNext(posother);
			CFODrawShape *pParent = pOther->GetMainShape();
			if (pParent != NULL)
			{
				if (pParent->IsKindOf(RUNTIME_CLASS(CFOCompositeShape)))
				{
					CFOCompositeShape *pComp = static_cast<CFOCompositeShape *>(pParent);
					if (pComp->GetCompCount() <= 1)
					{
						AfxMessageBox(IDS_FOP_COMP_REMOVE, MB_OK | MB_ICONINFORMATION);
					}
					else
					{
						CFORemoveCompAction *pRemoveAction = new CFORemoveCompAction(GetCurrentModel(), pOther);
						pRemoveAction->SetCompShape(pComp);
						pAction->AddAction(pRemoveAction);
					}
				}
			}
		}
	}

	if (m_ListTemp.GetCount() > 0)
	{
		pAction->AddAction(new CFORemoveCompsAction(GetCurrentModel(), m_ListTemp));
	}

	if (bNeedDo)
	{
		if (!GetCurrentModel()->Do(pAction, TRUE))
		{
			delete pAction;
		}

		ClearSelection();
	}
	else
	{
		delete pAction;
	}
	return NULL;
}



void CVisioDrawView::OnUpdateHideAllSnap(CCmdUI *pCmdUI)
{
	// TODO: ڴû洦
	pCmdUI->SetCheck(!gfxData.m_bWithSnap);
}


void CVisioDrawView::OnFontColor()
{
	// TODO: ڴ
	CMainFrame *pParent = STATIC_DOWNCAST(CMainFrame, AfxGetMainWnd());
	ASSERT_VALID(pParent);
	CMFCRibbonBar* pRibbon = pParent->GetRibbonBar();
	ASSERT_VALID(pRibbon);

	CMFCRibbonColorButton * pBtnColor = DYNAMIC_DOWNCAST(
		CMFCRibbonColorButton, pRibbon->FindByID(ID_FONT_COLOR));
	if (pBtnColor != NULL)
	{
		return;
	}

}


void CVisioDrawView::OnUpdateFontColor(CCmdUI *pCmdUI)
{
	// TODO: ڴû洦
}


void CVisioDrawView::OnCloneNow()
{
	// TODO: Add your command handler code here
	BOOL bControl = FALSE;
	if (HIBYTE(GetKeyState(VK_CONTROL)))
	{
		bControl = TRUE;
	}

	if (bControl)
	{
		if (m_listSelectComp.GetCount() == 1)
		{

			CFODrawShapeList lstUpdate;

			CFODrawShape *pObj = (CFODrawShape *)GetCurrentSelectShape();
			if (pObj != NULL)
			{
				if (pObj != NULL)
				{
					FOPPoint ptOffset = FindTheBestClone(pObj, TRUE);
					DoCloneMoveShapesList(ptOffset);
				}
			}
		}
		else if (m_listSelectComp.GetCount() > 1)
		{
			FOPRect rcNew = GetCurrentModel()->GetTotalSnapRect(m_listSelectComp);

			FOPPoint ptOffset = rcNew.TopLeft();

			ptOffset.x += rcNew.Width() + gfxData.m_nDefCloneSpace;
			ptOffset.y = 0;
			DoCloneMoveShapesList(ptOffset);
		}
	}
	else
	{
		if (m_listSelectComp.GetCount() == 1)
		{

			CFODrawShapeList lstUpdate;

			CFODrawShape *pObj = (CFODrawShape *)GetCurrentSelectShape();
			if (pObj != NULL)
			{
				if (pObj != NULL)
				{
					FOPPoint ptOffset = FindTheBestClone(pObj, FALSE);
					DoCloneMoveShapesList(ptOffset);
				}
			}
		}

		else if (m_listSelectComp.GetCount() > 1)
		{
			FOPRect rcNew = GetCurrentModel()->GetTotalSnapRect(m_listSelectComp);

			FOPPoint ptOffset = rcNew.TopLeft();

			ptOffset.y += rcNew.Height() + gfxData.m_nDefCloneSpace;
			ptOffset.x = 0;
			DoCloneMoveShapesList(ptOffset);
		}
	}
}

void CVisioDrawView::OnUpdateCloneNow(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here

}


void CVisioDrawView::OnViewPapercolor()
{
	// TODO: ڴ
	CFOColorDialog dlg;
	dlg.SetColor(GetCurrentModel()->GetBkColor());
	if (dlg.DoModal() == IDOK)
	{
		GetCurrentModel()->ChangeModelColorProp(dlg.GetColor(), M_ID_BK_COLOR);
		FOPInvalidate();
	}
}


void CVisioDrawView::OnUpdateViewPapercolor(CCmdUI *pCmdUI)
{
	// TODO: ڴû洦
}
